/**
 * The MIT License (MIT)
 *
 * Copyright (c) 2018 Erik Moqvist
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/**
 * This file was generated by cantools version 29.6.0 Sat Dec  1 09:19:46 2018.
 */

#include <string.h>

#include "floating_point.h"

#define UNUSED(x) (void)(x)

ssize_t floating_point_message1_encode(
    uint8_t *dst_p,
    const struct floating_point_message1_t *src_p,
    size_t size)
{
    uint64_t signal1;

    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    memcpy(&signal1, &src_p->signal1, sizeof(signal1));
    dst_p[0] |= ((signal1 << 0) & 0xffu);
    dst_p[1] |= ((signal1 >> 8) & 0xffu);
    dst_p[2] |= ((signal1 >> 16) & 0xffu);
    dst_p[3] |= ((signal1 >> 24) & 0xffu);
    dst_p[4] |= ((signal1 >> 32) & 0xffu);
    dst_p[5] |= ((signal1 >> 40) & 0xffu);
    dst_p[6] |= ((signal1 >> 48) & 0xffu);
    dst_p[7] |= ((signal1 >> 56) & 0xffu);

    return (8);
}

int floating_point_message1_decode(
    struct floating_point_message1_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    uint64_t signal1;

    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    signal1 = 0ull;
    signal1 |= ((uint64_t)(src_p[0] & 0xffu) >> 0);
    signal1 |= ((uint64_t)(src_p[1] & 0xffu) << 8);
    signal1 |= ((uint64_t)(src_p[2] & 0xffu) << 16);
    signal1 |= ((uint64_t)(src_p[3] & 0xffu) << 24);
    signal1 |= ((uint64_t)(src_p[4] & 0xffu) << 32);
    signal1 |= ((uint64_t)(src_p[5] & 0xffu) << 40);
    signal1 |= ((uint64_t)(src_p[6] & 0xffu) << 48);
    signal1 |= ((uint64_t)(src_p[7] & 0xffu) << 56);
    memcpy(&dst_p->signal1, &signal1, sizeof(dst_p->signal1));

    return (0);
}

bool floating_point_message1_signal1_is_in_range(double value)
{
    UNUSED(value);

    return (true);
}

ssize_t floating_point_message2_encode(
    uint8_t *dst_p,
    const struct floating_point_message2_t *src_p,
    size_t size)
{
    uint32_t signal1;
    uint32_t signal2;

    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    memcpy(&signal1, &src_p->signal1, sizeof(signal1));
    dst_p[0] |= ((signal1 << 0) & 0xffu);
    dst_p[1] |= ((signal1 >> 8) & 0xffu);
    dst_p[2] |= ((signal1 >> 16) & 0xffu);
    dst_p[3] |= ((signal1 >> 24) & 0xffu);
    memcpy(&signal2, &src_p->signal2, sizeof(signal2));
    dst_p[4] |= ((signal2 << 0) & 0xffu);
    dst_p[5] |= ((signal2 >> 8) & 0xffu);
    dst_p[6] |= ((signal2 >> 16) & 0xffu);
    dst_p[7] |= ((signal2 >> 24) & 0xffu);

    return (8);
}

int floating_point_message2_decode(
    struct floating_point_message2_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    uint32_t signal1;
    uint32_t signal2;

    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    signal1 = 0u;
    signal1 |= ((uint32_t)(src_p[0] & 0xffu) >> 0);
    signal1 |= ((uint32_t)(src_p[1] & 0xffu) << 8);
    signal1 |= ((uint32_t)(src_p[2] & 0xffu) << 16);
    signal1 |= ((uint32_t)(src_p[3] & 0xffu) << 24);
    memcpy(&dst_p->signal1, &signal1, sizeof(dst_p->signal1));
    signal2 = 0u;
    signal2 |= ((uint32_t)(src_p[4] & 0xffu) >> 0);
    signal2 |= ((uint32_t)(src_p[5] & 0xffu) << 8);
    signal2 |= ((uint32_t)(src_p[6] & 0xffu) << 16);
    signal2 |= ((uint32_t)(src_p[7] & 0xffu) << 24);
    memcpy(&dst_p->signal2, &signal2, sizeof(dst_p->signal2));

    return (0);
}

bool floating_point_message2_signal1_is_in_range(float value)
{
    UNUSED(value);

    return (true);
}

bool floating_point_message2_signal2_is_in_range(float value)
{
    UNUSED(value);

    return (true);
}
