/**
 * The MIT License (MIT)
 *
 * Copyright (c) 2018 Erik Moqvist
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/**
 * This file was generated by cantools version 29.6.0 Sat Dec  1 09:19:45 2018.
 */

#include <string.h>

#include "motohawk.h"

#define UNUSED(x) (void)(x)

ssize_t motohawk_example_message_encode(
    uint8_t *dst_p,
    const struct motohawk_example_message_t *src_p,
    size_t size)
{
    uint16_t temperature;

    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->enable << 7) & 0x80u);
    dst_p[0] |= ((src_p->average_radius << 1) & 0x7eu);
    temperature = (uint16_t)src_p->temperature;
    dst_p[0] |= ((temperature >> 11) & 0x01u);
    dst_p[1] |= ((temperature >> 3) & 0xffu);
    dst_p[2] |= ((temperature << 5) & 0xe0u);

    return (8);
}

int motohawk_example_message_decode(
    struct motohawk_example_message_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    uint16_t temperature;

    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->enable |= ((uint8_t)(src_p[0] & 0x80u) >> 7);
    dst_p->average_radius |= ((uint8_t)(src_p[0] & 0x7eu) >> 1);
    temperature = 0u;
    temperature |= ((uint16_t)(src_p[0] & 0x01u) << 11);
    temperature |= ((uint16_t)(src_p[1] & 0xffu) << 3);
    temperature |= ((uint16_t)(src_p[2] & 0xe0u) >> 5);

    if ((temperature & (1u << 11)) != 0u) {
        temperature |= 0xf000u;
    }

    dst_p->temperature = (int16_t)temperature;

    return (0);
}

bool motohawk_example_message_enable_is_in_range(uint8_t value)
{
    UNUSED(value);

    return (true);
}

bool motohawk_example_message_average_radius_is_in_range(uint8_t value)
{
    return (value <= 50u);
}

bool motohawk_example_message_temperature_is_in_range(int16_t value)
{
    return ((value >= -2048) && (value <= 2047));
}
