/**
 * The MIT License (MIT)
 *
 * Copyright (c) 2018 Erik Moqvist
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/**
 * This file was generated by cantools version 29.6.0 Sat Dec  1 09:19:46 2018.
 */

#include <string.h>

#include "multiplex.h"

#define UNUSED(x) (void)(x)

ssize_t multiplex_message1_encode(
    uint8_t *dst_p,
    const struct multiplex_message1_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->multiplexor << 2) & 0xfcu);

    switch (src_p->multiplexor) {

    case 8:
        dst_p[2] |= ((src_p->bit_j << 2) & 0x04u);
        dst_p[2] |= ((src_p->bit_c << 3) & 0x08u);
        dst_p[2] |= ((src_p->bit_g << 7) & 0x80u);
        dst_p[3] |= ((src_p->bit_l << 0) & 0x01u);
        break;

    case 16:
        dst_p[2] |= ((src_p->bit_j << 2) & 0x04u);
        dst_p[2] |= ((src_p->bit_c << 3) & 0x08u);
        dst_p[2] |= ((src_p->bit_g << 7) & 0x80u);
        dst_p[3] |= ((src_p->bit_l << 0) & 0x01u);
        break;

    case 24:
        dst_p[2] |= ((src_p->bit_j << 2) & 0x04u);
        dst_p[2] |= ((src_p->bit_c << 3) & 0x08u);
        dst_p[2] |= ((src_p->bit_g << 7) & 0x80u);
        dst_p[3] |= ((src_p->bit_l << 0) & 0x01u);
        dst_p[3] |= ((src_p->bit_a << 2) & 0x04u);
        dst_p[3] |= ((src_p->bit_k << 4) & 0x10u);
        dst_p[3] |= ((src_p->bit_e << 5) & 0x20u);
        dst_p[4] |= ((src_p->bit_d << 0) & 0x01u);
        dst_p[4] |= ((src_p->bit_b << 1) & 0x02u);
        dst_p[4] |= ((src_p->bit_h << 6) & 0x40u);
        dst_p[4] |= ((src_p->bit_f << 7) & 0x80u);
        break;

    default:
        break;
    }

    return (8);
}

int multiplex_message1_decode(
    struct multiplex_message1_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->multiplexor |= ((uint8_t)(src_p[0] & 0xfcu) >> 2);

    switch (dst_p->multiplexor) {

    case 8:
        dst_p->bit_j |= ((uint8_t)(src_p[2] & 0x04u) >> 2);
        dst_p->bit_c |= ((uint8_t)(src_p[2] & 0x08u) >> 3);
        dst_p->bit_g |= ((uint8_t)(src_p[2] & 0x80u) >> 7);
        dst_p->bit_l |= ((uint8_t)(src_p[3] & 0x01u) >> 0);
        break;

    case 16:
        dst_p->bit_j |= ((uint8_t)(src_p[2] & 0x04u) >> 2);
        dst_p->bit_c |= ((uint8_t)(src_p[2] & 0x08u) >> 3);
        dst_p->bit_g |= ((uint8_t)(src_p[2] & 0x80u) >> 7);
        dst_p->bit_l |= ((uint8_t)(src_p[3] & 0x01u) >> 0);
        break;

    case 24:
        dst_p->bit_j |= ((uint8_t)(src_p[2] & 0x04u) >> 2);
        dst_p->bit_c |= ((uint8_t)(src_p[2] & 0x08u) >> 3);
        dst_p->bit_g |= ((uint8_t)(src_p[2] & 0x80u) >> 7);
        dst_p->bit_l |= ((uint8_t)(src_p[3] & 0x01u) >> 0);
        dst_p->bit_a |= ((uint8_t)(src_p[3] & 0x04u) >> 2);
        dst_p->bit_k |= ((uint8_t)(src_p[3] & 0x10u) >> 4);
        dst_p->bit_e |= ((uint8_t)(src_p[3] & 0x20u) >> 5);
        dst_p->bit_d |= ((uint8_t)(src_p[4] & 0x01u) >> 0);
        dst_p->bit_b |= ((uint8_t)(src_p[4] & 0x02u) >> 1);
        dst_p->bit_h |= ((uint8_t)(src_p[4] & 0x40u) >> 6);
        dst_p->bit_f |= ((uint8_t)(src_p[4] & 0x80u) >> 7);
        break;

    default:
        break;
    }

    return (0);
}

bool multiplex_message1_multiplexor_is_in_range(uint8_t value)
{
    UNUSED(value);

    return (true);
}

bool multiplex_message1_bit_j_is_in_range(uint8_t value)
{
    UNUSED(value);

    return (true);
}

bool multiplex_message1_bit_c_is_in_range(uint8_t value)
{
    UNUSED(value);

    return (true);
}

bool multiplex_message1_bit_g_is_in_range(uint8_t value)
{
    UNUSED(value);

    return (true);
}

bool multiplex_message1_bit_l_is_in_range(uint8_t value)
{
    UNUSED(value);

    return (true);
}

bool multiplex_message1_bit_a_is_in_range(uint8_t value)
{
    UNUSED(value);

    return (true);
}

bool multiplex_message1_bit_k_is_in_range(uint8_t value)
{
    UNUSED(value);

    return (true);
}

bool multiplex_message1_bit_e_is_in_range(uint8_t value)
{
    UNUSED(value);

    return (true);
}

bool multiplex_message1_bit_d_is_in_range(uint8_t value)
{
    UNUSED(value);

    return (true);
}

bool multiplex_message1_bit_b_is_in_range(uint8_t value)
{
    UNUSED(value);

    return (true);
}

bool multiplex_message1_bit_h_is_in_range(uint8_t value)
{
    UNUSED(value);

    return (true);
}

bool multiplex_message1_bit_f_is_in_range(uint8_t value)
{
    UNUSED(value);

    return (true);
}
